// Version 3.0.0

//###########################################################################
//###########################################################################
//####                                                                   ####
//####                           Olivier Pécheux                         ####
//####                          Olivier@Pecheux.fr                       ####
//####                         (33) +6 69 77 82 58                       ####
//####         http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph        ####
//####                                                                   ####
//###########################################################################
//###########################################################################

// Ceci est un complément aux pages de définition et d'explications de la
// librairie PecheuxGraph. Ce programme est une démonstration décrite dans la
// page http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph/ScreenShoot.html

// Ce programme affiche un fond, prend un point quelconque de l'écran, et le
// redessine (même couleur). Il appelle ensuite point sans donner de
// paramètre couleur pour les 4 points adjacents. Le dessin se mélange
// jusqu'à ce qu'une couleur prenne le dessus
// Avec une photo, c'est plus long si on travaille sur l'écran complet, mais
// c'est plus intéressant. L'image va devenir floue, elle sera définie par de
// moins en moins de pixels
 
#include <PecheuxGraph.h>
#define TAILLE 40

void setup() 
{
  // Fond d'écran:
  setGraphMode(PAYSAGE); // Initialisation de l'écran
  initSD(); // Si déja pas de carte...
  if (bpxDraw("320x240/21.bpx",0,0))
    for (int x=0; x<320/TAILLE; x++) for (int y=0; y<320/TAILLE; y++)
        fillRect(x*TAILLE,y*TAILLE,x*TAILLE+TAILLE,y*TAILLE+TAILLE,RANDOM_COLOR);
}

int x, y; // Coordonnés d'un point quelconque
word couleur; // Couleur du point
void loop()
{
  // Prendre un point au hasard
  x=random(LARGEUR); y=random(HAUTEUR);
  couleur=getPoint(x,y);
  // 4 colorier les 4 points adjacents de la même couleur
  point(x,y-1,couleur); // Point au dessus
  point(x,y+1,couleur); // Point en dessous
  point(x-1,y,couleur); // Point à gauche
  point(x+1,y,couleur); // Point à droite
}
