// Version 3.0.0

//###########################################################################
//###########################################################################
//####                                                                   ####
//####                           Olivier Pécheux                         ####
//####                          Olivier@Pecheux.fr                       ####
//####                         (33) +6 69 77 82 58                       ####
//####         http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph        ####
//####                                                                   ####
//###########################################################################
//###########################################################################

// Ceci est un complément aux pages de définition et d'explications de la
// librairie PecheuxGraph. Ce programme est une démonstration décrite dans la
// page http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph/ScreenShoot.html

// Le point N°1 tourne autour du centre avec une vitesse de vitesse1 et à une
// distance de rayon1. Un point N°2 tourne autour du point N°1 avec une
// vitesse de vitesse2 et à une distance de rayon2. Est tracé le chemin du
// point N°2.

#include <PecheuxGraph.h>
void setup() 
{
  setGraphMode(PAYSAGE); // Obligatoire pour utiliser l'afficheur
}

long debut;
void loop()
{
  float increment=PI/3000; // Increment de l'angle
  float angle=0; // Qui va croître
  int vitesse1, // Le point A tourne d'un angle angle*vitesse1
      rayon1, // Et à une distance de rayon1 du centre de l'écran
      vitesse2, // Le point B tourne d'un angle angle*vitesse2
      rayon2; // Et à une distance de rayon2 du point A
  
  rayon1=random(70)+50;  // 50 à 119 
  rayon2=119-rayon1; // le compément à 119 pour avoir le maximum d'espace occupé
  vitesse1=random(6)+1; // entre 1 et 6
  vitesse2=random(6)+10; // entre 10 et 16
  clrscr();
  debut=millis();
  while (debut+5000>millis())
  {
    point(DEMI_LARGEUR+trunc(rayon1*cos(angle*vitesse1)+rayon2*cos(angle*vitesse2)), DEMI_HAUTEUR+trunc(rayon1*sin(angle*vitesse1)+rayon2*sin(angle*vitesse2)));                                       
    angle+=increment;
  }
}
