// Version 3.0.0

//###########################################################################
//###########################################################################
//####                                                                   ####
//####                           Olivier Pécheux                         ####
//####                          Olivier@Pecheux.fr                       ####
//####                         (33) +6 69 77 82 58                       ####
//####         http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph        ####
//####                                                                   ####
//###########################################################################
//###########################################################################


// Ceci est un complément aux pages de définition et d'explications de la
// librairie PecheuxGraph. Ce programme illustre l'utilisation de la fonction
// initSD() décrite dans la page
// http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph/Definition/initSDExemple.html

// Ce programme donne la liste des fichiers présents dans la racine de la
// carte SD. Il faut bien entendu avoir une carte SD présente. Pour plus
// d'informations sur ce programme, se reporter à la bibliothèque SdFat

#include <PecheuxGraph.h>
#include <SD.h>

File racine; // Pour ouvrir la carte SD
File fichier; // Pour parcourir la racine de la carte SD

void setup() 
{
  setGraphMode(PAYSAGE); // Obligatoire pour utiliser l'afficheur

  if (initSD()) // remplace SB.begin
  {
    // Ecrit la lite des fichiers, voit la bibliothèque SD...
    racine=SD.open("/");
    fichier=racine.openNextFile();
    while (fichier)
    {
      if (fichier.isDirectory()) text("<");
      text(fichier.name());
      if (fichier.isDirectory()) text(">");
      text("\n");
      fichier.close();
      fichier=racine.openNextFile();  
    }
  }  
}

void loop()
{
}
