// Version 3.0.0

//###########################################################################
//###########################################################################
//####                                                                   ####
//####                           Olivier Pécheux                         ####
//####                          Olivier@Pecheux.fr                       ####
//####                         (33) +6 69 77 82 58                       ####
//####         http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph        ####
//####                                                                   ####
//###########################################################################
//###########################################################################


// Ceci est un complément aux pages de définition et d'explications de la
// librairie PecheuxGraph. Ce programme illustre l'utilisation de la fonction text() décrite dans la page  
// http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph/Definition/textExemple.html

// Ce programme affice en taille 2 tous les caractères imprimables, le retour chariot et le tabulateur.
// Pour ce dernier, est affiché 3 lignes de 3 caractères, comme une grille de morpion.

#include <PecheuxGraph.h>
void setup() 
{
  setGraphMode(PAYSAGE); // Initialisation générale
  Serial.begin(115200);
  
  for (char c=33; c<127; c++) text(String(c)); // Affiche les premiers caractères qui tiennent sur un seul octet
  text(F("àáâçèéêëîï°±òóôµö÷ùúûü€")); // Ceux-ci ne corrrespondent pas au code ascii, mais sont imprimables
  text(F("\n\nRetour chariot ---> \\n\n")); // Le retour chariot, c'est \n. Pour écrire \ il faut en mettre 2!
  text(F("Tabulateur ---> \\t\n\n")); // Le tabulateur, c'est \t.
  text(F("O\\tX\\tX\\nX\\tO\\tO\\nX\\tO\\tO:\n")); // Grille de morpion, pour explications
  text(F("O\tX\tX\nX\tO\tO\nX\tO\tO")); // Grille de morpion, pour dessin
}

void loop()
{
}
