// Version 3.0.0

//###########################################################################
//###########################################################################
//####                                                                   ####
//####                           Olivier Pécheux                         ####
//####                          Olivier@Pecheux.fr                       ####
//####                         (33) +6 69 77 82 58                       ####
//####         http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph        ####
//####                                                                   ####
//###########################################################################
//###########################################################################


// Ceci est un complément aux pages de définition et d'explications de la
// librairie PecheuxGraph. Ce programme illustre l'utilisation de la fonction isTouch() décrite dans la page  
// http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph/Definition/isTouchExemple.html

// Le générateur pseudo aléatoire random() va toujours nous donner la même séquence.
// Pour éviter cela, il faut appeler la fonction randomSeed et lui passer un nombre.
// Mais il faut trouver un nombre de départ variable! On utilise souvent à cet effet 
// la lecture d'une broche analogique. Cela va nous donner une séquence parmi 256
// au maximum. On peut alors utiliser un temps de réaction de l'humain. Dans
// l'exemple qui suit, on demande à l'utilisateur de toucher l'écran. Le temps qu'il
// va mette est variable et on a donc une valeur de départ aléatoire.
//
// Avec la ligne while(!isTouch()); désactivée (elle est en commentaire), la
// séquence sera toujours la même 737, 845, 656... en supprimant les // en début de
// ligne, l'affichage commencera aléatoirement.

#include <PecheuxGraph.h>
void setup() 
{
  setGraphMode(PAYSAGE);

  text("Appuyez sur l'écran");
  while(!isTouch()); // Attend que l'on appuie sur l'écran
  randomSeed(micros()); // Initialise le générateur aléatoire

  setTextSize(5); setTextBold(2); // Ecrit un peu gros
}

void loop()
{
  clrscr();
  text(String(random(1000))); // Affiche un nombre au hasard
  delay(1000); // Toutes les secondes
}
