// Version 3.0.0

//###########################################################################
//###########################################################################
//####                                                                   ####
//####                           Olivier Pécheux                         ####
//####                          Olivier@Pecheux.fr                       ####
//####                         (33) +6 69 77 82 58                       ####
//####         http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph        ####
//####                                                                   ####
//###########################################################################
//###########################################################################


// Ceci est un complément aux pages de définition et d'explications de la
// librairie PecheuxGraph. Ce programme illustre l'utilisation de la fonction limites() décrites dans la page  
// http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph/Definition/limitesExemple.html

// Une croix est dessinée comme si elle suivait le stylet avec une trajectoire quelconque
// si on ne fait rien, sinon, elle suit le stylet

#include <PecheuxGraph.h>

void setup()
{
  setGraphMode(PAYSAGE); // Initialisation

  // Trace quelques objets
  text("Suivez la croix avec le stylet");
  fillCircle(100,100,50,RED);
  fillRect(160,160,300,300,BLUE);
}

float angle; // Pour avoir une trajectoire intéressante
int x,y; // Coordonnés d'un point de la trajectoire
long temps; // Permet de revenir au mode auto au bout de 3s
void loop()
{

  if (isTouch())
  {
    temps=millis(); // On note le dernier instant du contact
    croixCurseur(getTouchX(),getTouchY()); // Suivi du stylet
  }
  else // Pas de point de contact
    if (millis()-temps>3000) // Et attente dépassée
    {
      // Calcul d'une trajectoire bizare
      angle+=0.02; 
      x=DEMI_LARGEUR+trunc(60*cos(angle*6)+59*cos(angle*17));
      y=DEMI_HAUTEUR+trunc(60*sin(angle*15)+59*sin(angle*17));
      croixCurseur(x,y); // Suivi de la tajectoire
    }
}
