// Version 3.0.0

//###########################################################################
//###########################################################################
//####                                                                   ####
//####                           Olivier Pécheux                         ####
//####                          Olivier@Pecheux.fr                       ####
//####                         (33) +6 69 77 82 58                       ####
//####         http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph        ####
//####                                                                   ####
//###########################################################################
//###########################################################################


// Ceci est un complément aux pages de définition et d'explications de la
// librairie PecheuxGraph. Ce programme illustre l'utilisation de la classe
// Clock décrites dans la page  
// http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph/Definition/ClockExemple.html

// Mise en place d'un métronome. Toutes les 2s, il change la couleur du fond
// de l'écran

// Version 1:
// - L'horloge a une définition statique
// - Utilise onTimeFunction pour exécuter l'action à faire 

#include <PecheuxGraph.h> // Appel de la bibliothèque 

 
// Déclaration statique de l'instance, doit se faire en dehors du setup
// Si on la définissait dans le setup elle serait détruite au sortir du setup et
// en pariculier lorsque l'on en a besoin (dans le loop).
Clock metronome(2000); // Déclaration  d'un métronome, action toutes les 2 secondes


// Déclaration d'une fonction qui fera ce qu'il faut faire toutes les fin de comptage
// Peut se mettre avant ou après la déclaration de l'instance horloge
// Cette fonction ne doit pas avoir de paramètres et ne doit rien retourner
// Le nom peut être quelconque
void onTimeAction(void)
{
  clrscr(RANDOM_COLOR); // Action à faire chaque seconde
}


void setup()
{
  setGraphMode(PAYSAGE); // Pour pouvoir utiliser clrscr()

  // Association de la fonction qui va faire le travail avec le métronome
  // Attention, il y a un caractère "&" avant le nom de la fonction.
  // Cette ligne veut dire: metronome a une propriété onTimeFunction et on va
  // affecter cette propriété avec l'adresse (présence du "&") de onTimeAction
  metronome.onTimeFunction=&onTimeAction; // Fonction à appeler toutes les secondes
}


void loop() 
{
  scanEvent(); // Gestion des boutons et des horloges, le plus souvent seul dans loop()
}
