// Version 3.0.0

//###########################################################################
//###########################################################################
//####                                                                   ####
//####                           Olivier Pécheux                         ####
//####                          Olivier@Pecheux.fr                       ####
//####                         (33) +6 69 77 82 58                       ####
//####         http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph        ####
//####                                                                   ####
//###########################################################################
//###########################################################################


// Ceci est un complément aux pages de définition et d'explications de la
// librairie PecheuxGraph. Ce programme illustre l'utilisation de la classe
// Clock décrites dans la page
// http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph/Definition/ClockExemple.html

// Version 3:
// - L'horloge a une définition dynamique dans le setup()
// - Utilise onTimeFunction pour exécuter l'action à faire

#include <PecheuxGraph.h> // Appel de la bibliothèque 


// Déclaration d'une fonction qui fera ce qu'il faut faire toutes les fin de comptage
// Cette fonction ne doit pas avoir de paramètres et ne doit rien retourner
// Le nom peut être quelconque
void onTimeAction(void)
{
  clrscr(RANDOM_COLOR); // Action à faire chaque seconde
}


void setup()
{
  setGraphMode(PAYSAGE); // Pour pouvoir utiliser clrscr()

  // Déclaration dynamique de l'instance, faite dans une fonction
  // Dans ce cas l'instance est accessible partout, mais le pointeur
  // horloge sera détruit en sortant de la fonction (ici du setup())
  Clock *horloge = new Clock(2000); // Déclaration  d'un métronome, action toutes les 2 secondes
  // Association de la fonction qui va faire le travail avec le métronome
  // Attention, il y a un caractère "&" avant le nom de la fonction.
  // Cette ligne veut dire: metronome a une propriété onTimeFunction et on va
  // affecter cette propriété avec l'adresse (présence du "&") de onTimeAction
  horloge->onTimeFunction = &onTimeAction; // Fonction à appeler toutes les secondes
}


void loop()
{
  scanEvent(); // Gestion des boutons et des horloges, le plus souvent seul dans loop()
}
