// Version 3.0.0

//###########################################################################
//###########################################################################
//####                                                                   ####
//####                           Olivier Pécheux                         ####
//####                          Olivier@Pecheux.fr                       ####
//####                         (33) +6 69 77 82 58                       ####
//####         http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph        ####
//####                                                                   ####
//###########################################################################
//###########################################################################


// Ceci est un complément aux pages de définition et d'explications de la
// librairie PecheuxGraph. Ce programme illustre l'utilisation de la classe
// PushZone décrites dans la page
// http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph/Definition/PushZoneExemple.html

// Mise em place de 3 bouton de type PushZone (pousoir sur une zone, pas de
// dessin dans le bouton). Quand on appuie sur un bouton, un disque blanc
// montre son activité

// Version 4:
// - On définir une classe Bouton, dérivée de PushZone, avec le bon comportement
// - Les boutons ont une définition statique

#include <PecheuxGraph.h> // Appel de la bibliothèque 


class Bouton: public PushZone // Nouvelle classe pour redéfinir onSelect
{
  public:
    Bouton(int x1, int y1, int x2, int y2): PushZone(x1, y1, x2, y2) {} // constructeur, on copie la classe mère
    virtual void onSelect() // Nouveau comportement si on le sélectionne
    {
      fillCircle(100, demiY1 * 2 + 20, 20, WHITE);
    }
    virtual void onUnselect() // Nouveau comportement si on le déselectionne
    {
      fillCircle(100, demiY1 * 2 + 20, 20, BLACK);
    }
}; // Ne pas oublier le ; à la fin de la déclaration d'une classe


// Déclaration statique des instances, doit se faire en dehors du setup
// Si on la définissait dans le setup elle serait détruite au sortir du setup et
// en pariculier lorsque l'on en a besoin (dans le loop).
Bouton boutonHaut(200, 40, 240, 80); // Bouton en haut
Bouton boutonCentre(200, 100, 240, 140); // Bouton au centre
Bouton boutonBas(200, 160, 240, 200); // Bouton en bas


void setup()
{
  setGraphMode(PAYSAGE); // Initialisation de la carte
  rect(200, 40, 240, 80, GREEN); // Carré du haut
  rect(200, 100, 240, 140, GREEN); // Carré au centre de l'écran
  rect(200, 160, 240, 200, GREEN); // Carré du bas
  text(F("Appuyez sur un carré"));

}


void loop()
{
  scanEvent(); // Gestion des boutons et des horloges, le plus souvent seul dans le loop
}
