// Version 3.0.0

//###########################################################################
//###########################################################################
//####                                                                   ####
//####                           Olivier Pécheux                         ####
//####                          Olivier@Pecheux.fr                       ####
//####                         (33) +6 69 77 82 58                       ####
//####         http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph        ####
//####                                                                   ####
//###########################################################################
//###########################################################################


// Ceci est un complément aux pages de définition et d'explications de la
// librairie PecheuxGraph. Ce programme illustre l'utilisation de la classe
// PushCoche décrites dans la page
// http://dansetrad.fr/Orgue_de_barbarie/PecheuxGraph/Definition/PushCocheExemple.html

// Mise em place de 3 bouton de type PushCoche (pousoir sur une zone, dessine
// carré avec une coche si il est pointé). On peut voir l'activité du bouton
// à la présence d'une coche sous le stylet. La zone d'action est bien plus
// grande que le dessin, on peut donc pointer légèrement à côté

// Les boutons ont une définition statique

#include <PecheuxGraph.h> // Appel de la bibliothèque 


// Déclaration statique des instances, doit se faire en dehors du setup
// Dans ce cas les boutons sont accessibles partout
PushCoche boutonHaut(200, 40, 240, 80); // Bouton en haut
PushCoche boutonCentre(200, 100, 240, 140); // Bouton au centre
PushCoche boutonBas(200, 160, 240, 200); // Bouton en bas


void setup()
{
  // Si on veut changer la couleur par défaut des boutons, il vaut mieux le
  // faire avant qu'ils soient dessinés. La première fois c'est à l'appel de
  // setGraphMode(), les fois suivantes c'est leors des aoppui et des
  // relâchements.
  PushCoche::buttonColor=BLUE;
  
  setGraphMode(PAYSAGE); // Initialisation de la carte
  text(F("Appuyez sur un bouton"));
}


void loop()
{
  scanEvent(); // Gestion des boutons et des horloges, le plus souvent seul dans le loop
}
